/*
	PIP - Platform Independent Primitives
	Digest algorithms
	Ivan Pelipenko peri4ko@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "pidigest_siphash_p.h"

#include "3rd/SipHash/halfsiphash.h"
#include "3rd/SipHash/siphash.h"
#include "3rd/SipHash/vectors.h"


PIByteArray SipHash::siphash(const PIByteArray & in, const PIByteArray & key, int out_bytes) {
	PIByteArray ret(out_bytes);
	static PIByteArray empty_key(16, 0);
	if (key.isEmpty())
		::siphash(in.data(), in.size(), empty_key.data(), ret.data(), ret.size());
	else {
		if (key.size() >= 16)
			::siphash(in.data(), in.size(), key.data(), ret.data(), ret.size());
		else {
			auto skey = key.resized(16);
			::siphash(in.data(), in.size(), skey.data(), ret.data(), ret.size());
		}
	}
	return ret;
}


PIByteArray SipHash::halfsiphash(const PIByteArray & in, const PIByteArray & key, int out_bytes) {
	PIByteArray ret(out_bytes);
	static PIByteArray empty_key(8, 0);
	if (key.isEmpty())
		::halfsiphash(in.data(), in.size(), empty_key.data(), ret.data(), ret.size());
	else {
		if (key.size() >= 8)
			::halfsiphash(in.data(), in.size(), key.data(), ret.data(), ret.size());
		else {
			auto skey = key.resized(8);
			::halfsiphash(in.data(), in.size(), skey.data(), ret.data(), ret.size());
		}
	}
	return ret;
}
